/*******************************
 * 
 * 骑享程序测试
 * 
 * ****************************/
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "app.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include <cis_def.h>
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"

//空间及变量定义
#define PROC_MAIN_TASK_STACK_SIZE           (1024)
#define PROC_UART_TASK_STACK_SIZE           (1024)
#define PROC_CAN_TASK_STACK_SIZE           (1024)

uint8_t deepslpTimerID          = DEEPSLP_TIMER_ID7;
uint8_t MainSlpHandler          = 0xff;
uint8_t UartSlpHandler          = 0xfe;
uint8_t CanSlpHandler          = 0xfd;


#define Uart_Send_LEN         (8)
#define Uart_Rece_LEN         (40)

#define RTE_UART_RX_IO_MODE      RTE_UART1_RX_IO_MODE
extern ARM_DRIVER_USART Driver_USART1;
static ARM_DRIVER_USART *USARTdrv = &Driver_USART1;
volatile bool isRecvTimeout = false;
volatile bool isRecvComplete = false;
QueueHandle_t gpsMsgQueue = NULL;
uint8_t Batt_Cell_Num = 14;//默认数值14、17
uint8_t Batt_Cell_Num_2 ;//默认数值
uint8_t Batt_Temp_Num = 5;//默认数值5、7
int16_t Uart_Rece_BattI=0x0000;
uint8_t Can_Rece_buffer[8];
volatile bool Can_Enable = false;
uint16_t data_index = 0x0000;
volatile bool Sleep_Flag = false;
uint8_t battbuffer[100];//电池数据都存在此数组中————电压14，温度5
/**
 *  存放规则如下：
 * 位置：   0       1       2       3       4       5       6       7       8       9       10      11      12      13      14      15              16             
 * 数据：   年      月      日      时      分      秒    信息体标志  年      月      日      时      分       秒    网络信号  故障等级  故障代码高     故障代码低
 * 
 *         17      18       19          20          21          22         23       24      25      26 27 28 29   30       30+1 .... 30+X*2      31+X*2       31+1...31+X*2+N
 *         电流H    电流L  Link电压H    Link电压L   Pack电压H   Pack电压L   开关状态   SOC     SOH    均衡状态      单体个数X    单体v1...单体vX   温度个数N     温度1..温度N    
 *          32+X*2+N     33+X*2+N   34+x*2+N    35 +X*2+N    36+X*2 +N    37+X*2+N
 *          电池状态    是否加热       最高单体H    最高单体L   最低单体H      最低单体L
 * */
//GPS信息
extern GPS_INFO Gps_Data;
//状态机定义
typedef enum
{
    PROCESS_STATE_IDLE = 0,
    PROCESS_STATE_WORK,
    PROCESS_STATE_SLEEP
}process_Main;
static process_Main 		    gProcess_Main_Task = PROCESS_STATE_IDLE;
#define PROC_MAIN_STATE_SWITCH(a)  (gProcess_Main_Task = a)

typedef enum
{
    PROCESS_UART_STATE_IDLE = 0,
    PROCESS_UART_STATE_CHECK,
    PROCESS_UART_STATE_WORK,
    PROCESS_UART_STATE_SLEEP
}process_Uart;
static process_Uart             gProcess_Uart_Task = PROCESS_UART_STATE_IDLE;
#define PROC_UART_STATE_SWITCH(a)  (gProcess_Uart_Task = a)

typedef enum
{
    PROCESS_CAN_STATE_IDLE = 0,
    PROCESS_CAN_STATE_RECV,
    PROCESS_CAN_STATE_SEND,
    PROCESS_CAN_STATE_SLEEP
}process_CAN;
static process_CAN 		    gProcess_Can_Task = PROCESS_CAN_STATE_IDLE;
#define PROC_CAN_STATE_SWITCH(a)  (gProcess_Can_Task = a)

//堆栈申请
static StaticTask_t             gProcess_Main_Task_t;
static UINT8                  gProcess_Main_TaskStack[PROC_UART_TASK_STACK_SIZE];
static StaticTask_t             gProcess_Uart_Task_t;
static UINT8                  gProcess_Uart_TaskStack[PROC_UART_TASK_STACK_SIZE];
static StaticTask_t             gProcess_Can_Task_t;
static UINT8                  gProcess_Can_TaskStack[PROC_CAN_TASK_STACK_SIZE];

//睡眠进出函数
static void appBeforeHib(void *pdata, slpManLpState state)
{
    uint32_t *p_param = (uint32_t *)pdata;

    #ifdef USING_PRINTF
        printf("Before Hibernate:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);

}

static void appAfterHib(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("Try Hibernate Failed:%d \n",state);
    #endif
}


static void appBeforeSlp1(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("Before Sleep1:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);
}

static void appAfterSlp1(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("After Sleep1:%d \n",state);
    #endif
}


static void appBeforeSlp2(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("before sleep2:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);
}

static void appAfterSlp2(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("sleep2 failed:%d \n",state);
    #endif
}
// 主任务线程
static void Main_Task(void* arg)
{
    UINT16 Can_index = 0;
    UINT16 Uart_index = 0;
    UINT16 NB_index  = 0;
    uint32_t sleep_index = 0;
    int32_t inParam = 0xAABBCCDD;
    PROC_MAIN_STATE_SWITCH(PROCESS_STATE_IDLE);
    NetSocDisplay(LED_SOC_0,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_1,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_2,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_3,LED_TURN_OFF);
    FaultDisplay(LED_TURN_OFF);
    NVIC_EnableIRQ(PadWakeup1_IRQn);
    slpManSetPmuSleepMode(true,SLP_HIB_STATE,false);
    slpManApplyPlatVoteHandle("MainSlp",&MainSlpHandler);
    slpManPlatVoteDisableSleep(MainSlpHandler, SLP_SLP2_STATE); 

    slpManRegisterUsrdefinedBackupCb(appBeforeHib,&inParam,SLPMAN_HIBERNATE_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterHib,NULL,SLPMAN_HIBERNATE_STATE);

    slpManRegisterUsrdefinedBackupCb(appBeforeSlp1,NULL,SLPMAN_SLEEP1_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterSlp1,NULL,SLPMAN_SLEEP1_STATE);

    slpManRegisterUsrdefinedBackupCb(appBeforeSlp2,NULL,SLPMAN_SLEEP2_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterSlp2,NULL,SLPMAN_SLEEP2_STATE);

    slpManSlpState_t slpstate = slpManGetLastSlpState();

    #ifdef USING_PRINTF
            printf("slpstate:%d \n",slpstate);
    #endif
    if((slpstate == SLP_SLP2_STATE) || (slpstate == SLP_HIB_STATE))
    {
        PROC_MAIN_STATE_SWITCH(PROCESS_STATE_IDLE);
    }
    else
    {
        PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
    }
    //线程初始化完成
    while (true)
    {
        switch(gProcess_Main_Task)
        {
            case PROCESS_STATE_IDLE:
            {
                // 暂时不区分唤醒
                PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
                break;
            }
            case PROCESS_STATE_WORK:
            {
                NetSocDisplay(LED_SOC_0,LED_TURN_ON);
                osDelay(10/portTICK_PERIOD_MS);
                Can_index++;
                Uart_index++;
                NB_index++;
                if (Uart_index >100)//Uart 1s 调用一次
                {
                    PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_WORK);
                    Uart_index = 0;
                }
                if (Can_index >=10)//Can 1s 调用一次
                {
                    PROC_CAN_STATE_SWITCH(PROCESS_CAN_STATE_RECV);
                    Can_index = 0;
                }
                if (NB_index >=100)//NB 1s 调用一次
                {
                    NB_index = 0;
                }
                if(!Can_Enable)
                {
                    sleep_index++;
                }
                else
                {
                    sleep_index = 0;
                }
                if (sleep_index >=60000)
                {
                    PROC_MAIN_STATE_SWITCH(PROCESS_STATE_SLEEP);
                    sleep_index = 0;
                }
                break;
            }
            case PROCESS_STATE_SLEEP:
            {
                Sleep_Flag = true;
                while((gProcess_Uart_Task!=PROCESS_UART_STATE_SLEEP)||(gProcess_Can_Task!=PROCESS_CAN_STATE_SLEEP))
                {
                    PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_SLEEP);
                    PROC_CAN_STATE_SWITCH(PROCESS_CAN_STATE_SLEEP);
                }
                osDelay(1000);
                slpManSlpState_t State;
                uint8_t cnt;
                if(slpManCheckVoteState(MainSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Main State, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif						
                }
                slpManPlatVoteEnableSleep(MainSlpHandler, SLP_SLP2_STATE); 
                if(slpManCheckVoteState(MainSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Main State Again, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif					
                }
                #ifdef USING_PRINTF
                            printf("[%d]Waiting sleep\r\n",__LINE__);
                #endif
                FaultDisplay(LED_TURN_ON);
                slpManSlpState_t slpstate = slpManPlatGetSlpState();
                #ifdef USING_PRINTF
                    printf("which slpstate can go now :%d \n",slpstate);
                #endif
                #ifdef USING_PRINTF
                    printf("Main_Sleep\n");
                #endif
                slpManDeepSlpTimerStart(deepslpTimerID,60000); 
                while(1)
                {
                    osDelay(5000/portTICK_PERIOD_MS);
                }
            }
        }

    }
    

}

//Uart校验程序
unsigned int crc_chk(uint8_t* data, uint8_t length)
{  
    int j;
    uint16_t reg_crc=0xFFFF;
    while(length--)
    { 
        reg_crc ^= *data++;
        for(j=0;j<8;j++)
        { 
            if(reg_crc & 0x01)
            {
                reg_crc=(reg_crc>>1) ^ 0xA001;
            }
            else
            {
                reg_crc=reg_crc >>1;
            }
        }
    }
    return reg_crc;
}
//Uart回调程序
void USART_callback(uint32_t event)
{
    if(event & ARM_USART_EVENT_RX_TIMEOUT)
    {
        isRecvTimeout = true;
    }
    if(event & ARM_USART_EVENT_RECEIVE_COMPLETE)
    {
        isRecvComplete = true;
    }
}
//Uart发送接收函数
uint8_t* Uart_Receive_func(Uart_Receive_Type Uart_Receive_Msg,uint8_t* Uart_Rece_buffer,uint8_t Data_Len)
{
    uint16_t CRC_Rece_buffer;
    uint16_t CRC_chk_buffer;
    uint8_t Uart_Send_buffer[8];
    Uart_Send_buffer[0] = Uart_Receive_Msg.Bms_Address;
    Uart_Send_buffer[1] = Uart_Receive_Msg.Bms_Read_Funcode;
    Uart_Send_buffer[2] = Uart_Receive_Msg.Reg_Begin_H;
    Uart_Send_buffer[3] = Uart_Receive_Msg.Reg_Begin_L;
    Uart_Send_buffer[4] = Uart_Receive_Msg.Reg_Num_H;
    Uart_Send_buffer[5] = Uart_Receive_Msg.Reg_Num_L;
    CRC_chk_buffer = crc_chk(Uart_Send_buffer,6);
    Uart_Send_buffer[6] = CRC_chk_buffer;
    Uart_Send_buffer[7] = CRC_chk_buffer>>8;
    uint32_t timeout = 0x00000000;
    USARTdrv->Send(Uart_Send_buffer,8);
    // #ifdef USING_PRINTF
    // printf("Uart_Send_buffer:  ");
    // for(int i=0;i<8;i++)
    // {
    //     printf("%x ",Uart_Send_buffer[i]);
    // }
    //  printf("\n");
    // #endif
    USARTdrv->Receive(Uart_Rece_buffer,Data_Len);
    while((isRecvTimeout == false) && (isRecvComplete == false))
    {
        timeout++;
        if (timeout>=7000000)
        {
            timeout =0;
            isRecvTimeout = true;
            break;
        }
    }
    if (isRecvComplete == true)
    {
        #ifdef USING_PRINTF
        #endif
        isRecvComplete = false;
        CRC_Rece_buffer =*(Uart_Rece_buffer+Data_Len-1)<<8|*(Uart_Rece_buffer+Data_Len-2);
        CRC_chk_buffer = crc_chk(Uart_Rece_buffer,Data_Len-2);
        // #ifdef USING_PRINTF
        //     printf("Uart_Rece_buffer: ");
        //     for(int i=0;i<Data_Len;i++)
        //     {
        //     printf("%x ",*(Uart_Rece_buffer+i));
        //     }
        //     printf("crcchk:%x,%x\n ",CRC_chk_buffer,CRC_Rece_buffer);
        // #endif
        if (CRC_Rece_buffer == CRC_chk_buffer)//满足校验
        {
            return Uart_Rece_buffer;//此处指针移位出现重启问题
        }
        else //接收数据的校验不过屏蔽
        {
            memset(Uart_Rece_buffer,0xff,Data_Len);
            return Uart_Rece_buffer;
        }
    }
    else 
    {
        memset(Uart_Rece_buffer,0x00,Data_Len);
        isRecvTimeout = false;
        osDelay(100);
        return Uart_Rece_buffer;
    }


}
void GGACallBack(UINT8 res, UINT8 * params)
{
#ifdef USING_PRINTF	
	printf("GPS:len=%d,data=%s\r\n",res,params);
#else
       ECOMM_STRING(UNILOG_PLA_STRING, GPS_DATA, P_INFO, "gps:%s", params);
#endif
}
//Uart线程
static void Uart_Task(void* arg)
{
    USARTdrv->Initialize(USART_callback);
    USARTdrv->PowerControl(ARM_POWER_FULL);
    USARTdrv->Control(ARM_USART_MODE_ASYNCHRONOUS |
                      ARM_USART_DATA_BITS_8 |
                      ARM_USART_PARITY_NONE |
                      ARM_USART_STOP_BITS_1 |
                      ARM_USART_FLOW_CONTROL_NONE, 9600);
    int Rece_index = 0;
    volatile  uint8_t Data_Len;
    Uart_Receive_Type Uart_Receive_Msg;
    memset(&battbuffer[0],0x00,100);
	PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_IDLE);
    slpManApplyPlatVoteHandle("UARTSLP",&UartSlpHandler);
    slpManPlatVoteDisableSleep(UartSlpHandler, SLP_SLP2_STATE); 
    Uart_Receive_Msg.Bms_Address = 0x01;
    Uart_Receive_Msg.Bms_Read_Funcode = 0x03;
    uint8_t *Uart_Rece_buffer = NULL;
    volatile bool Uart_task = false;
    Batt_Cell_Num_2 = Batt_Cell_Num<<1;
    while (true)
    {
        switch (gProcess_Uart_Task)
        {
            case PROCESS_UART_STATE_IDLE:
            {    
                Rece_index = 0;
                break;
            }
            case PROCESS_UART_STATE_CHECK:
            {
                Uart_Rece_buffer = (uint8_t *)malloc(Uart_Rece_LEN);
                Uart_Receive_Msg.Reg_Begin_H = 0x00;
                Uart_Receive_Msg.Reg_Begin_L= 0x02+Batt_Cell_Num;
                Uart_Receive_Msg.Reg_Num_H = 0x00;
                Uart_Receive_Msg.Reg_Num_L = 0x01;
                Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                memset(Uart_Rece_buffer,0x00,Data_Len);
                Uart_Rece_buffer = Uart_Receive_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                Uart_Rece_BattI = *(Uart_Rece_buffer+3+0)<<8 |*(Uart_Rece_buffer+3+1);
                #ifdef USING_PRINTF
                        printf("Check_Current!\n");
                #endif
                PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_IDLE);
                free(Uart_Rece_buffer);
                break;
            }
            case PROCESS_UART_STATE_WORK:
            {
                #ifdef USING_PRINTF
                        printf("Uart work!\n");
                #endif
                Uart_task = false;
                Uart_Rece_buffer = (uint8_t *)malloc(Uart_Rece_LEN);
                while(!Uart_task)
                {
                    switch (Rece_index)
                    {
                        case 0://current
                        {
                            Uart_Receive_Msg.Reg_Begin_H = 0x00;
                            Uart_Receive_Msg.Reg_Begin_L= 0x02+Batt_Cell_Num;
                            Uart_Receive_Msg.Reg_Num_H = 0x00;
                            Uart_Receive_Msg.Reg_Num_L = 0x01;
                            Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                            memset(Uart_Rece_buffer,0x00,Data_Len);
                            Uart_Rece_buffer = Uart_Receive_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                            Uart_Rece_BattI = *(Uart_Rece_buffer+3+0)<<8 |*(Uart_Rece_buffer+3+1);
                            break;
                        }
                        case 1://cell votage
                        {
                            Uart_Receive_Msg.Reg_Begin_H = 0x00;
                            Uart_Receive_Msg.Reg_Begin_L = 0x02;
                            Uart_Receive_Msg.Reg_Num_H = Batt_Cell_Num>>8;
                            Uart_Receive_Msg.Reg_Num_L = Batt_Cell_Num;
                            Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                            memset(Uart_Rece_buffer,0x00,Data_Len);
                            Uart_Rece_buffer = Uart_Receive_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                            battbuffer[30] = Batt_Cell_Num;
                            memcpy(&battbuffer[31],Uart_Rece_buffer+3,Batt_Cell_Num_2);
                            break;
                        }
                        case 2://temprature
                        {
                            Uart_Receive_Msg.Reg_Begin_H = 0x00;
                            Uart_Receive_Msg.Reg_Begin_L = 0x06+Batt_Cell_Num;
                            Uart_Receive_Msg.Reg_Num_H = Batt_Temp_Num>>8;
                            Uart_Receive_Msg.Reg_Num_L = Batt_Temp_Num;
                            Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                            memset(Uart_Rece_buffer,0x00,Data_Len);
                            Uart_Rece_buffer = Uart_Receive_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                            battbuffer[31+Batt_Cell_Num_2] = Batt_Temp_Num;
                            for (int i = 0; i < Batt_Temp_Num; i++)
                            {
                                battbuffer[32+Batt_Cell_Num_2+i] = *(Uart_Rece_buffer+3+2*i+1);
                            }
                            break;
                        }
                        case 3://batt votage
                        {
                            Uart_Receive_Msg.Reg_Begin_H = 0x00;
                            Uart_Receive_Msg.Reg_Begin_L = 0x18+Batt_Cell_Num+Batt_Temp_Num;
                            Uart_Receive_Msg.Reg_Num_H = 0x00;
                            Uart_Receive_Msg.Reg_Num_L = 0x01;
                            Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                            memset(Uart_Rece_buffer,0x00,Data_Len);
                            Uart_Rece_buffer = Uart_Receive_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                            battbuffer[19] = *(Uart_Rece_buffer+3+0);//Link U
                            battbuffer[20] = *(Uart_Rece_buffer+3+1);
                            battbuffer[21] = *(Uart_Rece_buffer+3+0);//Pack U
                            battbuffer[22] = *(Uart_Rece_buffer+3+1);
                            break;
                        }
                        case 4://soc,soh
                        {
                            Uart_Receive_Msg.Reg_Begin_H = 0x00;
                            Uart_Receive_Msg.Reg_Begin_L = 0x09+Batt_Cell_Num+Batt_Temp_Num;
                            Uart_Receive_Msg.Reg_Num_H = 0x00;
                            Uart_Receive_Msg.Reg_Num_L = 0x04;
                            Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                            memset(Uart_Rece_buffer,0x00,Data_Len);
                            Uart_Rece_buffer = Uart_Receive_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                            battbuffer[23] = *(Uart_Rece_buffer+3+0)>>1;//mos状态
                            battbuffer[24] = *(Uart_Rece_buffer+3+5);//SOC
                            battbuffer[25] = *(Uart_Rece_buffer+3+7);//SOH
                            break;
                        }
                        case 5://均衡
                        {
                            Uart_Receive_Msg.Reg_Begin_H = 0x00;
                            Uart_Receive_Msg.Reg_Begin_L = 0x06+Batt_Cell_Num+Batt_Temp_Num;
                            Uart_Receive_Msg.Reg_Num_H = 0x00;
                            Uart_Receive_Msg.Reg_Num_L = 0x02;
                            Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                            memset(Uart_Rece_buffer,0x00,Data_Len);
                            Uart_Rece_buffer = Uart_Receive_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                            memcpy(&battbuffer[26],Uart_Rece_buffer+3,4);
                            break;
                        }
                        case 6:
                        {
                            Uart_Receive_Msg.Reg_Begin_H = 0x00;
                            Uart_Receive_Msg.Reg_Begin_L = 0x19+Batt_Cell_Num+Batt_Temp_Num;
                            Uart_Receive_Msg.Reg_Num_H = 0x00;
                            Uart_Receive_Msg.Reg_Num_L = 0x02;
                            Data_Len = Uart_Receive_Msg.Reg_Num_L*2+5;
                            memset(Uart_Rece_buffer,0x00,Data_Len);
                            Uart_Rece_buffer = Uart_Receive_func(Uart_Receive_Msg,Uart_Rece_buffer,Data_Len);
                            memcpy(&battbuffer[34+Batt_Cell_Num_2+Batt_Temp_Num],Uart_Rece_buffer+3,4);
                            break; 
                        }
                        default:
                        {
                            PROC_UART_STATE_SWITCH(PROCESS_UART_STATE_IDLE);
                            Uart_task = true;
                            break;
                        }
                    }
                    Rece_index++;
                }
                free(Uart_Rece_buffer);
                break;
            }
            case PROCESS_UART_STATE_SLEEP:
            {
                slpManPlatVoteEnableSleep(UartSlpHandler, SLP_SLP2_STATE);
                while(true)
                {
                    osDelay(5000/portTICK_PERIOD_MS);
                }
            }
        }
    }

}
static void Can_Task(void* arg)
{
    uint32_t Can_ID;
    Can_InitType param;
    Can_TxMsgType Can_TxMsg;
    param.baudrate = CAN_500Kbps;
    param.mode = REQOP_NORMAL;
    //过滤ID配置
    param.TxStdIDH = 0x00;
    param.TxStdIDL = 0x00;
    param.RxStdIDH[0] = 0x00;
    param.RxStdIDL[0] = 0x00;
    /*stdid 0000 0000 001x*/
    param.RxStdIDH[1] = 0x00;
    param.RxStdIDL[1] = 0x20;
    /*stdid 0000 0000 010x */
    param.RxStdIDH[2] = 0x00;
    param.RxStdIDL[2] = 0x40;
    /*stdid 0000 0000 011x*/
    param.RxStdIDH[3] = 0x00;
    param.RxStdIDL[3] =0x60;
    /*stdid 0000 0000 100x */
    param.RxStdIDH[4] = 0x00;
    param.RxStdIDL[4] = 0x80;
    /*stdid 0000 0000 101x*/
    param.RxStdIDH[5] = 0x00;
    param.RxStdIDL[5] =0xa0;
    //配置完毕
    param.packType = STD_PACK;
    HAL_Can_Init(param);
    int send_index = 0;
    uint16_t Batt_Cell_addU = 0x0000;
    slpManApplyPlatVoteHandle("CanSlp",&CanSlpHandler);
    slpManPlatVoteDisableSleep(CanSlpHandler, SLP_SLP2_STATE);
    volatile bool Can_Flag=false;
    PROC_CAN_STATE_SWITCH(PROCESS_CAN_STATE_IDLE);
    GPS_INFO Gps_Data;
    posGGAServiceStart(GGACallBack);

    while(1)
    {
        switch(gProcess_Can_Task)
        {
            case PROCESS_CAN_STATE_IDLE:
            {
                Can_Rece_buffer[0]=0xff;
                send_index = 0;
                break;
            }
            case PROCESS_CAN_STATE_RECV:
            {

                //加入GPS启动程序
                if(gpsMsgQueue == NULL)
	            {
		            gpsMsgQueue = osMessageQueueNew(1,sizeof(GPS_INFO), NULL);
	            }
                osMessageQueueGet(gpsMsgQueue, &Gps_Data, 0, 1000);
                #ifdef USING_PRINTF	
                    printf("Gpsmsgqueue: %d,%d,%d,%d\r\n\n",Gps_Data.latitude,Gps_Data.longitude,Gps_Data.speed,Gps_Data.direction);
                #endif 

                
                //can采用先接收后发送的策略
                HAL_Can_Receive(Can_Rece_buffer);
                if (Can_Rece_buffer[0]!=0xff)//满足can发送使能
                {
                    PROC_CAN_STATE_SWITCH(PROCESS_CAN_STATE_SEND);
                    Can_Enable = true;
                }
                else
                {
                    PROC_CAN_STATE_SWITCH(PROCESS_CAN_STATE_IDLE);
                    Can_Enable = false;
                }
                break;
            }
            case PROCESS_CAN_STATE_SEND:
            {
                Can_Flag=false;
                while(!Can_Flag)
                {
                    #ifdef USING_PRINTF
                        printf("Can_Send!\n");
                    #endif
                    switch(send_index)
                    {
                        case 0:
                        {
                            Can_ID = 0x001;
                            for (int i = 0; i < 8; i++)
                            {
                                Can_TxMsg.Data[i] = battbuffer[i+31+send_index*8];
                            }
                            Can_TxMsg.stdIDH = Can_ID>>3;
                            Can_TxMsg.stdIDL = Can_ID<<5;
                            Can_TxMsg.DLC  = 8;
                            HAL_Can_Transmit(Can_TxMsg);
                            break;
                        }
                        case 1:
                        {
                            Can_ID = 0x011;
                            for (int i = 0; i < 8; i++)
                            {
                                Can_TxMsg.Data[i] = battbuffer[i+31+send_index*8];
                            }
                            Can_TxMsg.stdIDH = Can_ID>>3;
                            Can_TxMsg.stdIDL = Can_ID<<5;
                            Can_TxMsg.DLC  = 8;
                            HAL_Can_Transmit(Can_TxMsg);
                            break;
                        }
                        case 2:
                        {
                            Can_ID = 0x020;
                            for (int i = 0; i < 8; i++)
                            {
                                Can_TxMsg.Data[i] = battbuffer[i+31+send_index*8];
                            }
                            Can_TxMsg.stdIDH = Can_ID>>3;
                            Can_TxMsg.stdIDL = Can_ID<<5;
                            Can_TxMsg.DLC  = 8;
                            HAL_Can_Transmit(Can_TxMsg);
                            break;
                        }
                        case 3:
                        {
                            Can_ID = 0x031;
                            for (int i = 0; i < 4; i++)
                            {
                                Can_TxMsg.Data[i] = battbuffer[i+31+send_index*8];
                            }
                            Can_TxMsg.Data[4] = 0x00;
                            Can_TxMsg.Data[5] = 0x00;
                            Can_TxMsg.Data[6] = 0x00;
                            Can_TxMsg.Data[7] = 0x00;
                            Can_TxMsg.stdIDH = Can_ID>>3;
                            Can_TxMsg.stdIDL = Can_ID<<5;
                            Can_TxMsg.DLC  = 8;
                            HAL_Can_Transmit(Can_TxMsg);
                            break;
                        }
                        case 4:
                        {
                            Can_ID  = 0x101;
                            for (int i = 0; i < Batt_Temp_Num; i++)
                            { 
                                Can_TxMsg.Data[i] = battbuffer[i+32+Batt_Cell_Num_2];
                            }
                            Can_TxMsg.stdIDH = Can_ID>>3;
                            Can_TxMsg.stdIDL = Can_ID<<5;
                            Can_TxMsg.DLC  = 8;
                            HAL_Can_Transmit(Can_TxMsg);
                            break;
                        }
                        case 5:
                        {
                            Batt_Cell_addU = 0x0000;
                            for (int i = 0; i < Batt_Cell_Num; i++)
                            {
                                Batt_Cell_addU = Batt_Cell_addU + (battbuffer[31+i*2]<<8|battbuffer[31+i*2+1]);
                            }
                            Can_ID = 0x201;
                            Can_TxMsg.Data[0] = battbuffer[19];
                            Can_TxMsg.Data[1] = battbuffer[20];
                            Can_TxMsg.Data[2] = battbuffer[21];
                            Can_TxMsg.Data[3] = battbuffer[22];//外电压
                            Can_TxMsg.Data[4] = Batt_Cell_addU>>8;
                            Can_TxMsg.Data[5] = Batt_Cell_addU;//累加电压
                            Can_TxMsg.Data[6] = Uart_Rece_BattI>>8;
                            Can_TxMsg.Data[7] = Uart_Rece_BattI;
                            Can_TxMsg.stdIDH = Can_ID>>3;
                            Can_TxMsg.stdIDL = Can_ID<<5;
                            Can_TxMsg.DLC  = 8;
                            HAL_Can_Transmit(Can_TxMsg);
                            break;

                        }
                        case 6:
                        {
                            Can_ID = 0x211;
                            Can_TxMsg.Data[0] = battbuffer[34+Batt_Cell_Num_2+Batt_Temp_Num];
                            Can_TxMsg.Data[1] = battbuffer[35+Batt_Cell_Num_2+Batt_Temp_Num];
                            Can_TxMsg.Data[2] = battbuffer[36+Batt_Cell_Num_2+Batt_Temp_Num];
                            Can_TxMsg.Data[3] = battbuffer[37+Batt_Cell_Num_2+Batt_Temp_Num];
                            Can_TxMsg.Data[4] = 0x00;
                            Can_TxMsg.Data[5] = 0x00;
                            Can_TxMsg.Data[6] = battbuffer[24];
                            Can_TxMsg.Data[7] = Batt_Temp_Num<<4|0;
                            Can_TxMsg.stdIDH = Can_ID>>3;
                            Can_TxMsg.stdIDL = Can_ID<<5;
                            Can_TxMsg.DLC  = 8;
                            HAL_Can_Transmit(Can_TxMsg);
                            break;
                        }
                        case 7:
                        {
                            Can_ID = 0x221;
                            Can_TxMsg.Data[0] = battbuffer[25];//SOH
                            Can_TxMsg.Data[1] = 0x00;
                            Can_TxMsg.Data[2] = 0x00;
                            Can_TxMsg.Data[3] = 0x00;
                            Can_TxMsg.Data[4] = 0x00;
                            Can_TxMsg.Data[5] = 0x00;
                            Can_TxMsg.Data[6] = 0x00;
                            Can_TxMsg.Data[7] = 0x00;
                            Can_TxMsg.stdIDH = Can_ID>>3;
                            Can_TxMsg.stdIDL = Can_ID<<5;
                            Can_TxMsg.DLC  = 8;
                            HAL_Can_Transmit(Can_TxMsg);
                            break;
                        }
                        default:
                        {
                            Can_Flag=true;
                            PROC_CAN_STATE_SWITCH(PROCESS_CAN_STATE_IDLE);
                            break;
                        }
                    }
                    send_index ++;
                }
                break;
            }
            case PROCESS_CAN_STATE_SLEEP:
            {
                posGGAServiceStop();
                slpManSlpState_t State;
                uint8_t cnt;
                if(slpManCheckVoteState(CanSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Can State, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif						
                }
                slpManPlatVoteEnableSleep(CanSlpHandler, SLP_SLP2_STATE); 
                if(slpManCheckVoteState(CanSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote can State Again, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif					
                }
                while(true)
                {
                    osDelay(5000/portTICK_PERIOD_MS);
                }
                break;
            }
        }
    }
}
//主任务线程初始化
void Main_Task_Init()
{
    #ifndef USING_PRINTF
    if(BSP_GetPlatConfigItemValue(PLAT_CONFIG_ITEM_LOG_CONTROL) != 0)
    {
        HAL_UART_RecvFlowControl(false);
    }
    #endif
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Main_TaskStack, 0xA5, PROC_MAIN_TASK_STACK_SIZE);
    task_attr.name = "Main_Task";
    task_attr.stack_mem = gProcess_Main_TaskStack;
    task_attr.stack_size = PROC_MAIN_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;
    task_attr.cb_mem = &gProcess_Main_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);

    osThreadNew(Main_Task, NULL, &task_attr);

}
//Uart读取线程初始化
void Uart_Task_Init()
{
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Uart_TaskStack, 0xA5, PROC_UART_TASK_STACK_SIZE);
    task_attr.name = "Uart_Task";
    task_attr.stack_mem = gProcess_Uart_TaskStack;
    task_attr.stack_size = PROC_UART_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;
    task_attr.cb_mem = &gProcess_Uart_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);

    osThreadNew(Uart_Task, NULL, &task_attr);

}
//Can线程初始化
void Can_Task_Init()
{
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Can_TaskStack, 0xA5, PROC_CAN_TASK_STACK_SIZE);
    task_attr.name = "Uart_Task";
    task_attr.stack_mem = gProcess_Can_TaskStack;
    task_attr.stack_size = PROC_CAN_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;
    task_attr.cb_mem = &gProcess_Can_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);

    osThreadNew(Can_Task, NULL, &task_attr);

}
void appInit(void *arg)
{
    Main_Task_Init();
    //Uart_Task_Init(); 暂时屏蔽Uart读取
    Can_Task_Init();
    GpsTaskInit();
}
//主函数入口
void main_entry(void) {

    BSP_CommonInit();
    osKernelInitialize();

    registerAppEntry(appInit, NULL);
    if (osKernelGetState() == osKernelReady)
    {
        osKernelStart();
    }
    while(1);
}
